Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/OBA/OBAOgreBase.h
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/OBA/OBAOgreBase.h	(revision 721)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/OBA/OBAOgreBase.h	(revision 731)
@@ -34,12 +34,23 @@
   protected:
 	  Ogre::ArchiveManager *mArchiveManager;
+	  
 	  Ogre::ResourceGroupManager *mResourceGroupManager;
+	  
 	  Ogre::DefaultHardwareBufferManager *mDefaultHardwareBufferManager;
+	  
 	  Ogre::MeshSerializer *mMeshSerializer;
+	  
+	  Ogre::MaterialSerializer *mMaterialSerializer;
+
 	  Ogre::XMLMeshSerializer *mXMLMeshSerializer;
+	  
 	  Ogre::MaterialManager *mMaterialManager;
+	  
 	  Ogre::LogManager *mLogManager;
+	  
 	  Ogre::MeshManager *mMeshManager;
+	  
 	  FileSystemArchiveFactory *mFileSystemArchiveFactory;
+
 	  Ogre::Math *mMath;
 
@@ -56,7 +67,7 @@
 	Ogre::XMLMeshSerializer* getXMLMeshSerializer();
 	
+	Ogre::MaterialSerializer* getMaterialSerializer();
+
 	Ogre::MeshSerializer* getMeshSerializer();
-
-	Ogre::MeshManager* getMeshManager();
 
 	void initialize();
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/LBBC/LBBCSampleConfigFile.h
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/LBBC/LBBCSampleConfigFile.h	(revision 721)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/LBBC/LBBCSampleConfigFile.h	(revision 731)
@@ -12,4 +12,6 @@
     virtual ~SampleConfigFile();
 
+	Ogre::String getEntitySampleMaterialPrefixName();
+
 	bool getEntityDistributionMerged();
 
@@ -20,5 +22,5 @@
 	bool getEntityDistributionSplitted();
 
-	Ogre::String getEntitySampleMeshPrefixFilename();
+	Ogre::String getEntitySampleMeshPrefixName();
 
 	bool getEntityDistributionGeneration();
@@ -26,5 +28,5 @@
 	Ogre::String getEntityDistributionFolder();
 
-	Ogre::String getEntityDistributionXMLPrefixFilename();
+	Ogre::String getEntityDistributionXMLPrefixName();
 
 	Ogre::String getEntitiesFolder();
@@ -32,5 +34,5 @@
 	bool getEntitySampleMeshGeneration();
 
-	Ogre::String getEntitiesMeshPrefixFilename();
+	Ogre::String getEntitiesMeshPrefixName();
 
 	bool getEntityClustersGeneration();
@@ -48,7 +50,7 @@
 	bool getEntityClustersSplittedClusters();
 
-	Ogre::String getEntityClustersMeshPrefixFilename();
+	Ogre::String getEntityClustersMeshPrefixName();
 
-	Ogre::String getEntityClustersMaterialPrefixFilename();
+	Ogre::String getEntityClustersMaterialPrefixName();
 
 	bool getBillboardCloudMergedBillboards();
@@ -60,25 +62,67 @@
 	Ogre::String getBillboardCloudFolder();
 
-	Ogre::String getBillboardCloudMeshPrefixFilename();
+	Ogre::String getBillboardCloudMeshPrefixName();
 
-	Ogre::String getBillboardCloudMaterialPrefixFilename();
+	Ogre::String getBillboardCloudBillboardMaterialPrefixName();
 
-	Ogre::String getBillboardCloudXMLPrefixFilename();
+	Ogre::String getBillboardCloudBillboardGroupMaterialPrefixName();
 
-	bool getBillboardCloudDiffuseColorTextureAtlasGeneration();
+	Ogre::String getBillboardCloudBillboardTextureUnit0PrefixName();
 
-	unsigned int getBillboardCloudDiffuseColorTextureSize();
+	Ogre::String getBillboardCloudBillboardGroupTextureUnit0PrefixName();
 
-	unsigned int getBillboardCloudDiffuseColorTextureAtlasSize();
-
-	bool getBillboardCloudIndirectTextureAtlasGeneration();
-
-	unsigned int getBillboardCloudIndirectTextureSize();
-
-	unsigned int getBillboardCloudIndirectTextureAtlasSize();
+	Ogre::String getBillboardCloudXMLPrefixName();
 
 	unsigned int getBillboardCloudGroups();
 
 	bool getBillboardCloudGroupedBillboards();
+
+	bool getBillboardCloudDiffuseColorEntityTextureAtlasGeneration();
+
+	Ogre::String getBillboardCloudDiffuseColorEntityTexturePrefixName();
+
+	Ogre::String getBillboardCloudDiffuseColorEntityTextureAtlasPrefixName();
+
+	unsigned int getBillboardCloudDiffuseColorEntityTextureAtlasBitRange();
+
+	unsigned int getBillboardCloudDiffuseColorEntityTextureAtlasSize();
+
+	unsigned int getBillboardCloudDiffuseColorBillboardGroupTextureSize();
+
+	bool getBillboardCloudIndirectBillboardGroupTextureAtlasGeneration();
+
+	Ogre::String getBillboardCloudIndirectBillboardGroupTextureAtlasPrefixName();
+
+	unsigned int getBillboardCloudIndirectBillboardGroupTextureAtlasBitRange();
+
+	unsigned int getBillboardCloudIndirectBillboardGroupTextureAtlasSize();
+
+	unsigned int getBillboardCloudIndirectBillboardGroupTextureSize();
+
+	bool getBillboardCloudDiffuseColorBillboardGroupTextureAtlasGeneration();
+
+	bool getBillboardCloudDiffuseColorMergedBillboardsTextureAtlasGeneration();
+
+	Ogre::String getBillboardCloudDiffuseColorMergedBillboardsTextureAtlasPrefixName();
+
+	unsigned int getBillboardCloudDiffuseColorMergedBillboardsTextureAtlasBitRange();
+
+	unsigned int getBillboardCloudDiffuseColorMergedBillboardsTextureAtlasSize();
+
+	unsigned int getBillboardCloudDiffuseColorMergedBillboardsTextureSize();
+
+	unsigned int getBillboardCloudDiffuseColorBillboardGroupTextureAtlasSize();
+
+	unsigned int getBillboardCloudDiffuseColorEntityTextureAtlasNumSamples();
+
+	bool getBillboardCloudIndirectMergedBillboardsTextureAtlasGeneration();
+
+	Ogre::String getBillboardCloudIndirectMergedBillboardsTextureAtlasPrefixName();
+
+	unsigned int getBillboardCloudIndirectMergedBillboardsTextureAtlasBitRange();
+
+	unsigned int getBillboardCloudIndirectMergedBillboardsTextureAtlasSize();
+
+	unsigned int getBillboardCloudIndirectMergedBillboardsTextureSize();
 
 };
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/LBBC/LBBCManager.h
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/LBBC/LBBCManager.h	(revision 721)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/LBBC/LBBCManager.h	(revision 731)
@@ -15,9 +15,9 @@
 namespace LBBC {
 
-class _BBCExport Manager : public BBC::Manager {
+class _BBCExport LBBCManager : public BBC::BBCManager {
   public:
-    Manager();
+    LBBCManager();
 
-    ~Manager();
+    ~LBBCManager();
 
 	void runSampleConfigFile();
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/LBBC/LBBC.h
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/LBBC/LBBC.h	(revision 721)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/LBBC/LBBC.h	(revision 731)
@@ -9,4 +9,4 @@
 #include <LBBCBillboardViewMode.h>
 #include <LBBCClusterViewMode.h>
-
+#include <LBBCEntityTextureAtlasViewMode.h>
 #endif
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/LBBC/LBBCClusterViewMode.h
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/LBBC/LBBCClusterViewMode.h	(revision 731)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/LBBC/LBBCClusterViewMode.h	(revision 731)
@@ -0,0 +1,30 @@
+#ifndef _LBBCCLUSTERSVIEWMODE_H
+#define _LBBCCLUSTERSVIEWMODE_H
+
+#include <LBBCPrerequisites.h>
+#include <OBAOgreFrameListenerMode.h>
+
+namespace LBBC {
+
+class ClusterViewMode : public OBA::OgreFrameListenerMode 
+{
+	public:
+		ClusterViewMode(Ogre::RenderWindow* win, unsigned int ogreFrameListenerModeHandle, bool useBufferedInputKeys = false, bool useBufferedInputMouse = false):
+		  OBA::OgreFrameListenerMode(win, ogreFrameListenerModeHandle, useBufferedInputKeys, useBufferedInputMouse)
+		{
+		}
+
+		virtual ~ClusterViewMode()
+		{
+		}
+
+		virtual void createScene()
+		{
+			Ogre::SceneNode* sNode = mSceneMgr->getRootSceneNode()->createChildSceneNode();
+			Ogre::Entity* emesh = mSceneMgr->createEntity("chestnutLeavesEntitySample.mesh", "chestnutLeavesEntitySample.mesh");		
+			sNode->attachObject(emesh);
+		}
+};
+
+}
+#endif
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/LBBC/LBBCEntityTextureAtlasViewMode.h
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/LBBC/LBBCEntityTextureAtlasViewMode.h	(revision 731)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/LBBC/LBBCEntityTextureAtlasViewMode.h	(revision 731)
@@ -0,0 +1,64 @@
+#ifndef _LBBCENTITYTEXTUREATLASVIEWMODE_H
+#define _LBBCENTITYTEXTUREATLASVIEWMODE_H
+
+#include <LBBCPrerequisites.h>
+#include <IMG.h>
+#include <OBAOgreFrameListenerMode.h>
+
+namespace LBBC {
+
+class _BBCExport EntityTextureAtlasViewMode : public OBA::OgreFrameListenerMode 
+{
+	protected:
+		Ogre::SceneNode* mTextureAtlasNode;
+
+		IMG::TextureAtlasPtr mTextureAtlas;
+
+		unsigned int mFrame;
+
+		bool mTextureAtlasGenerated;
+
+		unsigned int mBitRange;
+
+		Ogre::PixelFormat mSrcPixelFormat;
+
+		Ogre::PixelFormat mDestPixelFormat;
+
+		Ogre::String mTextureName;
+
+		Ogre::String mTextureAtlasName;
+
+		Ogre::String mTextureAtlasFolder;
+
+		unsigned int mTextureAtlasSize;
+
+		unsigned int mNumSamples;
+
+	public:
+		EntityTextureAtlasViewMode(Ogre::RenderWindow* win, unsigned int ogreFrameListenerModeHandle, bool useBufferedInputKeys = false, bool useBufferedInputMouse = false);
+
+		virtual ~EntityTextureAtlasViewMode();		
+
+		void setTextureAtlasFolder(Ogre::String textureAtlasFolder);
+
+		unsigned int nextPowerOf2(unsigned int nPlanes);
+
+		virtual bool frameStarted(const Ogre::FrameEvent& evt, Ogre::InputReader *inputReader);
+
+		virtual void createScene();
+
+		virtual void destroyScene();
+
+		void setTextureAtlasBitRange(unsigned int bitRange);
+
+		void setTextureAtlasNumSamples(unsigned int numSamples);
+
+		void setTextureName(Ogre::String textureName);
+
+		void setTextureAtlasName(Ogre::String textureAtlasName);
+
+		void setTextureAtlasSize(unsigned int size);
+};
+
+}
+#endif
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/LBBC/LBBCBillboardViewMode.h
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/LBBC/LBBCBillboardViewMode.h	(revision 731)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/LBBC/LBBCBillboardViewMode.h	(revision 731)
@@ -0,0 +1,31 @@
+#ifndef _LBBCBILLBOARDVIEWMODE_H
+#define _LBBCBILLBOARDVIEWMODE_H
+
+
+#include "OBAOgreFrameListenerMode.h"
+
+namespace LBBC {
+
+class BillboardViewMode : public OBA::OgreFrameListenerMode 
+{
+	public:
+		BillboardViewMode(Ogre::RenderWindow* win, unsigned int ogreFrameListenerModeHandle, bool useBufferedInputKeys = false, bool useBufferedInputMouse = false):
+		  OBA::OgreFrameListenerMode(win, ogreFrameListenerModeHandle, useBufferedInputKeys, useBufferedInputMouse)
+		{
+		}
+
+		virtual ~BillboardViewMode()
+		{
+		}
+
+		virtual void createScene()
+		{
+			Ogre::SceneNode* sNode = mSceneMgr->getRootSceneNode()->createChildSceneNode();
+			Ogre::Entity* emesh = mSceneMgr->createEntity("chestnutLeavesBillboardCloudMerged.mesh","chestnutLeavesBillboardCloudGrouped.mesh");		
+			sNode->attachObject(emesh);
+		}
+
+};
+
+}
+#endif
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/BBC/BBCMesh.h
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/BBC/BBCMesh.h	(revision 731)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/BBC/BBCMesh.h	(revision 731)
@@ -0,0 +1,65 @@
+#ifndef _BBCMESH_H
+#define _BBCMESH_H
+
+#include <BBCPrerequisites.h>
+
+namespace BBC {
+
+using namespace Ogre;
+
+//Fordward declaration
+class Mesh;
+
+namespace boost
+{
+	void intrusive_ptr_add_ref(Mesh * p);
+    void intrusive_ptr_release(Mesh * p);
+};
+
+class _BBCExport Mesh
+{
+  protected:
+	Ogre::Mesh* mMesh;
+
+  private:
+    long references;
+    friend void boost::intrusive_ptr_add_ref(Mesh * p);
+    friend void boost::intrusive_ptr_release(Mesh * p);
+
+  public:
+
+	Mesh(Ogre::Mesh* mesh): references(0) // initialize references to 0 
+	{
+		mMesh = mesh;
+	}
+	
+	Ogre::Mesh* get()
+	{
+		return mMesh;
+	}
+
+	virtual ~Mesh();
+};
+
+// class specific addref/release implementation
+// the two function overloads must be in the boost namespace on most compilers:
+namespace boost
+{
+	inline void intrusive_ptr_add_ref(Mesh * p)
+	{
+		// increment reference count of object *p
+		++(p->references);
+	}
+
+	inline void intrusive_ptr_release(Mesh * p)
+	{
+	// decrement reference count, and delete object when reference count reaches 0
+	if (--(p->references) == 0)
+		delete p;
+	} 
+} // namespace boost
+
+typedef ::boost::intrusive_ptr<Mesh> MeshPtr;
+
+}
+#endif
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/BBC/BBCManager.h
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/BBC/BBCManager.h	(revision 721)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/BBC/BBCManager.h	(revision 731)
@@ -7,13 +7,13 @@
 namespace BBC {
 
-class _BBCExport Manager : public CSingleton<Manager> {
+class _BBCExport BBCManager : public CSingleton<BBCManager> {
   public:
-    Manager();
+    BBCManager();
 	
-    ~Manager();
+    ~BBCManager();
 
-	static Manager& getSingleton(void);
+	static BBCManager& getSingleton(void);
     
-	static Manager* getSingletonPtr(void);
+	static BBCManager* getSingletonPtr(void);
 
 	Ogre::Mesh* loadMesh(Ogre::String folderName, Ogre::String fileName);
@@ -24,4 +24,6 @@
 
 	void saveXMLMesh(Ogre::String name);
+
+	void saveMaterial(Ogre::String materialName);
 
 	void initialize(void);
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/IBRBillboardCloudTreeApplication.h
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/IBRBillboardCloudTreeApplication.h	(revision 721)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/IBRBillboardCloudTreeApplication.h	(revision 731)
@@ -2,6 +2,7 @@
 #define _IBRBILLBOARDCLOUDTREEAPPLICATION_H
 
+#include <IMG.h>
+#include <LBBC.h>
 #include <OBAOgreApplication.h>
-#include <LBBC.h>
 #include <IBRBillboardCloudTreeFrameListener.h>
 
@@ -15,7 +16,9 @@
 protected:
 	
+	LBBC::SampleConfigFile *mSampleConfigFile;
+
 	CommandLineOptions mOpts;
 	
-	LBBC::Manager* mLBBCManager;
+	LBBC::LBBCManager* mLBBCManager;
 
 	int findCommandLineOpts(int numargs, char** argv, Ogre::UnaryOptionList& unaryOptList, Ogre::BinaryOptionList& binOptList);
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/IMG/IMGClusterList.h
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/IMG/IMGClusterList.h	(revision 721)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/IMG/IMGClusterList.h	(revision 731)
@@ -7,5 +7,5 @@
 namespace IMG {
 
-class ClusterList 
+class _IMGExport ClusterList 
 {
   public:
@@ -14,15 +14,15 @@
     virtual ~ClusterList();
     
-    std::vector<Cluster> * GetList();
+    std::vector<Cluster> * getList();
 
     //return the pointer to the list of voxels
-    unsigned int GetSize() const;
+    unsigned int getSize() const;
 
     //return the number of elements of list
-    Cluster * Get(unsigned int i);
+    Cluster * get(unsigned int i);
 
-    bool Insert(Cluster * p);
+    bool insert(Cluster * p);
 
-    void Print();
+    void print();
 
 
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/IMG/IMGBox2d.h
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/IMG/IMGBox2d.h	(revision 721)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/IMG/IMGBox2d.h	(revision 731)
@@ -7,5 +7,5 @@
 
 //* this class represents a 2d bound box for a texture 
-class Box2d 
+class _IMGExport Box2d 
 {
 	public:
@@ -22,19 +22,19 @@
 		}
 
-		Ogre::Vector2 GetMinimum();
+		Ogre::Vector2 getMinimum();
 
-		Ogre::Vector2 GetMaximum(); 
+		Ogre::Vector2 getMaximum(); 
 
-		void SetBoundBox(float x, float y, float X, float Y); 
+		void setBoundBox(float x, float y, float X, float Y); 
 
-		void AddBoundingVector3(float x, float y);
+		void addBoundingVector3(float x, float y);
 
-		void Print(); 
+		void print(); 
 
-		Ogre::Vector2 GetCorner(int corner) const;
+		Ogre::Vector2 getCorner(int corner) const;
 
-		bool In(int w, int h); 
+		bool in(int w, int h); 
 
-		bool FitPerfect(int w, int h);
+		bool fitPerfect(int w, int h);
 
 	protected:
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/IMG/IMG.h
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/IMG/IMG.h	(revision 721)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/IMG/IMG.h	(revision 731)
@@ -2,3 +2,6 @@
 #define _IMG_H
 
+#include <IMGTexture.h>
+#include <IMGTextureAtlas.h>
+
 #endif
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/IMG/IMGTexture.h
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/IMG/IMGTexture.h	(revision 731)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/IMG/IMGTexture.h	(revision 731)
@@ -0,0 +1,116 @@
+#ifndef _IMGTEXTURE_H
+#define _IMGTEXTURE_H
+
+#include <IMGPrerequisites.h>
+
+namespace IMG 
+{
+
+// Forward declarations
+class _IMGExport Texture;
+
+
+namespace boost
+{
+    void intrusive_ptr_add_ref(Texture * p);
+    void intrusive_ptr_release(Texture * p);
+};
+
+class _IMGExport Texture 
+{
+
+private:
+    long references;
+    friend void boost::intrusive_ptr_add_ref(Texture * p);
+    friend void boost::intrusive_ptr_release(Texture * p);
+
+  protected:
+	 Ogre::Texture *mTexture;
+
+	 Ogre::Material *mMaterial;
+
+     Ogre::Rectangle2D *mRectangle2D;
+
+	 unsigned int mWidth;
+
+	 unsigned int mHeight;
+
+	 Ogre::String mTextureName;
+
+	 Ogre::ColourValue mAvgColour;
+
+	 Ogre::ColourValue mBackgroundColour;
+
+	 bool mCalculatedAvgColour;
+
+  public:
+     Texture();
+
+     virtual ~Texture();
+
+	 Ogre::ColourValue getAvgColour();
+
+	 void calculateAvgColour();
+
+	 void setBackgroundColour(Ogre::ColourValue colour);
+
+	 Ogre::ColourValue getBackgroundColour();
+
+	 virtual void load(Ogre::String folderName, Ogre::String filename);
+
+	 virtual void save(Ogre::String folderName, Ogre::String filename);
+
+	 void rotate(Ogre::Real rRotation);
+
+	 void setCorners(Ogre::Real left, Ogre::Real top, Ogre::Real right, Ogre::Real bottom);
+
+	 Ogre::Rectangle2D* getRectangle2D();
+
+	 Ogre::Vector2 getMinTexCoord();
+
+	 Ogre::Vector2 getMaxTexCoord();
+
+     void setWidth(unsigned int width);
+
+     unsigned int getWidth();
+
+     void setHeight(unsigned int height);
+
+     unsigned int getHeight();
+
+     void setTextureName(Ogre::String textureName);
+
+     Ogre::String getTextureName();
+
+	 void setMaterial(Ogre::Material *material);
+
+	 Ogre::Material* getMaterial();
+
+	 void bind(Ogre::String textureName);
+
+};
+
+// class specific addref/release implementation
+// the two function overloads must be in the boost namespace on most compilers:
+namespace boost
+{
+ inline void intrusive_ptr_add_ref(Texture * p)
+  {
+    // increment reference count of object *p
+    ++(p->references);
+  }
+
+
+
+ inline void intrusive_ptr_release(Texture * p)
+  {
+   // decrement reference count, and delete object when reference count reaches 0
+   if (--(p->references) == 0)
+     delete p;
+  } 
+} // namespace boost
+
+typedef ::boost::intrusive_ptr<Texture> TexturePtr;
+
+}
+#endif
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/IMG/IMGCluster.h
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/IMG/IMGCluster.h	(revision 721)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/IMG/IMGCluster.h	(revision 731)
@@ -11,8 +11,10 @@
 {
 
-class Cluster 
+class _IMGExport Cluster 
 {
   public:
     Cluster();
+
+    virtual ~Cluster();
 
     Cluster & operator =(const Cluster & p);
@@ -20,43 +22,43 @@
     Cluster(const Cluster & p);
 
-	void SetNormal(Ogre::Vector3* n);
+	void setNormal(Ogre::Vector3* n);
 
-	Ogre::Vector3* GetNormal();
+	Ogre::Vector3* getNormal();
 
-    BBox* GetBound();
+    BBox* getBound();
 
-    Box2d* GetBspNodeBound();
+    Box2d* getBspNodeBound();
 
-    void SetBspNodeBound(Box2d* box);
+    void setBspNodeBound(Box2d* box);
 
-    void Print();
+    void print();
 
     //* return the dominant normal axis, for calculate the 2d projection
-    int AxisProjected();
+    int axisProjected();
 
-    int GetId() const;
+    int getId() const;
 
-    void SetId(int id_);
+    void setId(int id_);
 
-	std::vector<Ogre::Vector3>* GetVector3sVector();
+	std::vector<Ogre::Vector3>* getVector3sVector();
 
-	Ogre::Vector3* GetVector3sTex() const;
+	Ogre::Vector3* getVector3sTex() const;
 
-    void Finish();
+    void finish();
 
-	void SetPlane(Ogre::Vector3* normal, Ogre::Vector3 * point);
+	void setPlane(Ogre::Vector3* normal, Ogre::Vector3 * point);
 
-    Plane3 * GetPlane();
+    Plane3 * getPlane();
 
     //* Return the increment in U (lumel increment in x). For patchs calculation 
-	Ogre::Vector3 GetIncU();
+	Ogre::Vector3 getIncU();
 
     //* Return the increment in V (lumel increment in x). For patchs calculation 
-	Ogre::Vector3 GetIncV();
+	Ogre::Vector3 getIncV();
 
     //* Return the origin. For patchs calculation 
-	Ogre::Vector3 GetOrigin();
+	Ogre::Vector3 getOrigin();
 
-	bool PointIn(Ogre::Vector3 & point);
+	bool pointIn(Ogre::Vector3 & point);
 
 	Ogre::Real *pointeru[4]; 
@@ -93,7 +95,4 @@
     Plane3 plane;
 
-  public:
-    virtual ~Cluster();
-
 };
 
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/IMG/IMGPlane3.h
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/IMG/IMGPlane3.h	(revision 721)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/IMG/IMGPlane3.h	(revision 731)
@@ -6,5 +6,5 @@
 namespace IMG {
 
-class Plane3: public Ogre::Plane {
+class _IMGExport Plane3: public Ogre::Plane {
   public:
     //a plane's interface
@@ -15,13 +15,13 @@
     Plane3 & operator =(const Plane3 & p);
 
-	Ogre::Vector3 * GetNormal();
+	Ogre::Vector3 * getNormal();
 
-    void SetNormal(float x, float y, float z);
+    void setNormal(float x, float y, float z);
 
-    void SetDistance(float dist);
+    void setDistance(float dist);
 
-    float GetDistance() const;
+    float getDistance() const;
 
-    void Print();
+    void print();
 
 };
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/IMG/IMGBsp.h
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/IMG/IMGBsp.h	(revision 721)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/IMG/IMGBsp.h	(revision 731)
@@ -7,5 +7,5 @@
 namespace IMG {
 
-class Bsp {
+class _IMGExport Bsp {
   public:
     Bsp();
@@ -13,13 +13,13 @@
     virtual ~Bsp();
 
-    void SetRoot(NodeBspPtr node);
+    void setRoot(NodeBspPtr node);
 
-    void Print();
+    void print();
 
-    void PrintLeaf(); 
+    void printLeaf(); 
 
-    NodeBspPtr Insert(int w, int h, int idcluster);
+    NodeBspPtr insert(int w, int h, int idcluster);
 
-    NodeBspPtr Get(int i);
+    NodeBspPtr get(int i);
 
   protected:
@@ -30,7 +30,7 @@
     int counttotal;
 
-    void Print(NodeBspPtr node);
+    void print(NodeBspPtr node);
 
-    void PrintLeaf(NodeBspPtr node);
+    void printLeaf(NodeBspPtr node);
 
 };
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/IMG/IMGPrerequisites.h
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/IMG/IMGPrerequisites.h	(revision 721)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/IMG/IMGPrerequisites.h	(revision 731)
@@ -8,6 +8,16 @@
 #include <OgrePlane.h>
 #include <OgreAxisAlignedBox.h> 
+#include <OgreHardwarePixelBuffer.h>
+#include <OgreImageCodec.h>
+
+#include <imdebug.h>
 
 #include <boost/smart_ptr.hpp>
 
+#   	if defined( IMG_LIB_BUILD )
+#       	define _IMGExport __declspec( dllexport )			
+#   	else
+#       	define _IMGExport
+#   	endif
+
 #endif
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/IMG/IMGTextureAtlas.h
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/IMG/IMGTextureAtlas.h	(revision 731)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/IMG/IMGTextureAtlas.h	(revision 731)
@@ -0,0 +1,98 @@
+#ifndef _IMGTEXTUREATLAS_H
+#define _IMGTEXTUREATLAS_H
+
+#include <IMGPrerequisites.h>
+#include <IMGTexture.h>
+
+namespace IMG {
+
+// Fordward declaration...
+class TextureAtlas;
+
+namespace boost
+{
+    void intrusive_ptr_add_ref(TextureAtlas * p);
+    void intrusive_ptr_release(TextureAtlas * p);
+};
+
+class _IMGExport TextureAtlas : public Texture 
+{
+
+  private:
+    long references;
+    friend void boost::intrusive_ptr_add_ref(TextureAtlas * p);
+    friend void boost::intrusive_ptr_release(TextureAtlas * p);
+
+  protected:
+     Ogre::String mTextureAtlasName;
+
+	 Ogre::TexturePtr mTextureAtlas;
+
+	 Ogre::Camera *mCamera;
+	
+	 Ogre::SceneNode *mTextureAtlasSceneNode;
+
+     std::vector<TexturePtr> mTextureList;
+
+	 Ogre::PixelFormat mPixelFormat;
+
+  public:
+
+    TextureAtlas();
+
+    virtual ~TextureAtlas();
+
+	unsigned int getReference();
+
+	void setFormat(Ogre::PixelFormat pixelFormat);
+
+	void create(Ogre::String fileName, unsigned int width, unsigned int height, Ogre::PixelFormat pixelFormat, Ogre::Camera *camera);
+
+	void setCamera(Ogre::Camera *camera);
+
+	void update();
+
+	void setTextureAtlasSceneNode(Ogre::SceneNode *textureAtlasSceneNode);
+
+	Ogre::SceneNode* getTextureAtlasSceneNode();
+
+	void save(Ogre::String folderName, Ogre::String filename, Ogre::PixelFormat pixelFormat);
+
+	void addTexture(TexturePtr texture);
+
+	TexturePtr getTexture(unsigned int iTexture);
+
+	void removeTexture(unsigned int iTexture);
+
+    void setTextureAtlasName(Ogre::String textureAtlasName);
+
+    Ogre::String getTextureAtlasName();
+
+	unsigned int getNumTextures();
+
+};
+
+// class specific addref/release implementation
+// the two function overloads must be in the boost namespace on most compilers:
+namespace boost
+{
+ inline void intrusive_ptr_add_ref(TextureAtlas * p)
+  {
+    // increment reference count of object *p
+    ++(p->references);
+  }
+
+
+
+ inline void intrusive_ptr_release(TextureAtlas * p)
+  {
+   // decrement reference count, and delete object when reference count reaches 0
+   if (--(p->references) == 0)
+     delete p;
+  } 
+} // namespace boost
+
+typedef ::boost::intrusive_ptr<TextureAtlas> TextureAtlasPtr;
+
+}
+#endif
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/IMG/IMGCluster2d.h
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/IMG/IMGCluster2d.h	(revision 721)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/IMG/IMGCluster2d.h	(revision 731)
@@ -8,5 +8,5 @@
 class Cluster;
 
-class Cluster2d {
+class _IMGExport Cluster2d {
   public:
     Cluster2d();
@@ -17,13 +17,13 @@
     //			
     //	 
-    int Create2d(Cluster * cluster, int type, int type_vertexs);
+    int create2d(Cluster * cluster, int type, int type_vertexs);
 
-    void Print();
+    void print();
 
-	Ogre::Vector2 * GetVector3s();
+	Ogre::Vector2 * getVector3s();
 
-	std::vector<Ogre::Vector2> * GetVector3sVector();
+	std::vector<Ogre::Vector2> * getVector3sVector();
 
-	Ogre::Vector3 * GetNormal();
+	Ogre::Vector3 * getNormal();
 
   protected:
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/IMG/IMGBBox.h
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/IMG/IMGBBox.h	(revision 721)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/IMG/IMGBBox.h	(revision 731)
@@ -25,5 +25,5 @@
 //	this class encaplusalte the ogre::AxisAlignedBox
 //*
-class BBox: public Ogre::AxisAlignedBox {
+class _IMGExport BBox: public Ogre::AxisAlignedBox {
   public:
     BBox();
@@ -31,15 +31,15 @@
 	~BBox();
 
-    void StartBoundingBox();
+    void initialize();
 
-	Ogre::Vector3 GetMinimum();
+	Ogre::Vector3 getMinimum();
 
-	Ogre::Vector3 GetMaximum();
+	Ogre::Vector3 getMaximum();
 
-    void AddBoundingVector3(float x, float y, float z);
+    void addBoundingVector3(float x, float y, float z);
 
-    void Print();
+    void print();
 
-	Ogre::Vector3 GetCorner(int corner) const;
+	Ogre::Vector3 getCorner(int corner) const;
 
     bool intersects(Ogre::Vector3 v);
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/IMG/IMGNodeBsp.h
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/IMG/IMGNodeBsp.h	(revision 721)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/IMG/IMGNodeBsp.h	(revision 731)
@@ -8,5 +8,5 @@
 
 // Fordward declaration...
-class NodeBsp;
+class _IMGExport NodeBsp;
 
 typedef ::boost::intrusive_ptr<NodeBsp> NodeBspPtr;
@@ -25,21 +25,21 @@
     virtual ~NodeBsp();
 
-    Box2d* GetBound();
+    Box2d* getBound();
 
-    void SetBound(Box2d *box);
+    void setBound(Box2d *box);
 
-    NodeBspPtr GetChild(int i);
+    NodeBspPtr getChild(int i);
 
-    void SetId(int id_);
+    void setId(int id_);
 
-    unsigned int GetId() const;
+    unsigned int getId() const;
 
-    void SetChild(NodeBspPtr node, int i);
+    void setChild(NodeBspPtr node, int i);
 
-    void Print();
+    void print();
 
-    NodeBspPtr Insert(int w, int h);
+    NodeBspPtr insert(int w, int h);
 
-    NodeBspPtr Get(NodeBspPtr node, int i);
+    NodeBspPtr get(NodeBspPtr node, int i);
 
   protected:
